<template>
  <div>
    <b-container class="bv-example-row">
      <b-icon-skip-start font-scale="2" @click="goBack"></b-icon-skip-start>
      <h1 class="text-center">{{movie.title}}</h1>
      <b-row class="row">
        <b-col>
          <!-- Vérification qu'une image existe -->
          <img
            v-if="movie.poster_path != null"
            v-bind:src="'http://image.tmdb.org/t/p/w500' + movie.poster_path"
            width="300px"
          />
          <div v-else>
            <img src="../../public/no-image.png" width="300px" />
            <p class>Pas d'image à ce jour</p>
          </div>
        </b-col>
        <b-col class="overview">
          <!-- Vérification qu'un résumé existe -->
          <p v-if="movie.overview != ''">
            <i>{{movie.overview}}</i>
          </p>
          <p v-else>Pas de résumer !</p>
          <p class="director">
            <b>Réalisateur</b>
            : {{this.director}}
          </p>
        </b-col>
        <b-col>
          <div class="evaluation">
            <!-- Formulaire de critique -->
            <b-form @submit="onSubmit" @reset="onReset" v-if="show"> 
              <div class="note">
                <b-form-group label="Note">
                  <b-form-radio-group required v-model="form.note" :options="notes"></b-form-radio-group>
                </b-form-group>
                <div class="mt-3">
                  Note :
                  <strong>{{ form.note }}</strong>
                </div>
              </div>
              <b-form-group label="Commentaire">
                <b-form-textarea
                  id="textarea"
                  required
                  v-model="form.commentaire"
                  placeholder="Entrer votre critique"
                  rows="7"
                  max-rows="20"
                ></b-form-textarea>
              </b-form-group>

              <b-button type="submit" variant="primary">Envoyer</b-button>
              <b-button type="reset" variant="danger">Reset</b-button>
            </b-form>
          </div>
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>

<script>
import axios from "axios";
export default {
  props: ["dataCommentaire"],
  data() {
    return {
      results: "",
      movie: "",
      director: "",
      form: {
        note: "",
        commentaire: ""
      },
      show: true,
      notes: [
        // Liste des boutons radios
        { text: "1", value: "1" },
        { text: "2", value: "2" },
        { text: "3", value: "3" },
        { text: "4", value: "4" },
        { text: "5", value: "5" }
      ],
      notations: []
    };
  },
  mounted() {
    axios // Recuperation des crédits du film
      .get(
        "https://api.themoviedb.org/3/movie/" +
          this.$route.params.id +
          "/credits?api_key=8808341f6d652f0ef862338f6c67c723"
      )
      .then(response => {
        this.results = response.data.crew;
        // Tri pour récuperer seulement le Réalisateur
        for (let i = 0; i < this.results.length; i++) {
          if (this.results[i].job == "Director") {
            this.director = this.results[i].name;
          }
        }
      });

    axios // Recupération des informations du film (affiche, titre, résumé)
      .get(
        "https://api.themoviedb.org/3/movie/" +
          this.$route.params.id +
          "?api_key=8808341f6d652f0ef862338f6c67c723&language=fr&page=1&region=fr"
      )
      .then(response => {
        this.movie = response.data;
      });
  },
  methods: {
    // Function retour en arriere d'une page dans l'historique
    goBack() {
      this.$router.go(-1);
    },
    // Envoi du formulaire
    onSubmit(evt) {
      evt.preventDefault();
      // Envoi vers l'API
      axios.get("http://localhost:8000/api/"+this.movie.id+"/"+this.form.note+"/"+this.form.commentaire).then(function() {
        alert("Votre note et votre commentaire ont bien été enregistrés !");
      });
    },
    // Fonction de reset du formulaire
    onReset(evt) {
      evt.preventDefault();
      // Reset notre formulaire
      this.form.note = "";
      this.form.commentaire = "";
      this.show = false;
      this.$nextTick(() => {
        this.show = true;
      });
    }
  }
};
</script>

